SystemOrganization addCategory: #RTVoronyjBuilder!
SystemOrganization addCategory: 'RTVoronyjBuilder-Test'!

!SequenceableCollection methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 6/27/2014 23:28'!
uniqueTriCombiDo: aBlock

	self size < 3 ifTrue: [ ^ self ].
	
	(self allButLast: 2) withIndexDo: [ :fst :index1 | 
		((self allButLast) allButFirst: index1) withIndexDo: [ :snd :index2 | 
				(self allButFirst: index1 + index2) do: [ :trd |
					aBlock value: fst value: snd value: trd ] ] ]! !

TestCase subclass: #RTVoronyjBuilderGCircleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderGCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/5/2014 18:31'!
testPerpendicularBisectorsOn
	self
		assert: (((GCircle center: (-5@35) radius: 25.49509756796392 ) perpendicularBisectorsOn: { -30 @ 40 . -10 @ 10 . 20 @ 30 . 0 @ 60 })
		 at:(GSegment with:(-10@10) with:(20@30) ))origin
		equals:(-5 @ 35) .
		
	self
		assert: (((GCircle center: (-5@35) radius: 25.49509756796392 ) perpendicularBisectorsOn: { -30 @ 40 . -10 @ 10 . 20 @ 30 . 0 @ 60 })
		 at:(GSegment with:(-10@10) with:(20@30) ))direction
		equals: (5@20) ! !

TestCase subclass: #RTVoronyjBuilderGTriangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderGTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/5/2014 18:58'!
testPerpendicularBisectors
	self
		assert: ((GTriangle with: -30 @ 40 with: -10 @ 10 with: 20 @ 30) perpendicularBisectors at:(GSegment with:(-10@10) with:(20@30) ))origin
		equals:(-5 @ 35) .
	self
		assert: ((GTriangle with: -30 @ 40 with: -10 @ 10 with: 20 @ 30) perpendicularBisectors at:(GSegment with:(-10@10) with:(20@30) ))direction
		equals: (-4@(67/2)).	
	self
		assert: ((GTriangle with: -30 @ 40 with: -10 @ 10 with: 20 @ 30) perpendicularBisectors at:(GSegment with:(-30@40) with:(20@30) ))direction
		equals: (-4@40).	
! !

TestCase subclass: #RTVoronyjBuilderTest
	instanceVariableNames: 'builder builder1 builder2 builderCircle builder3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 12:36'!
setUp
	super setUp.
	builder := RTVoronyjBuilder new
		objects: { -1 @ 1 . 2 @ 3 . 5 @ -3 };
		positionBlock: #yourself;
		yourself.
	builder1 := RTVoronyjBuilder new
		objects: {  7 @ 4 . 5 @ 7 . -1 @ 1 . 2 @ 3 . 5 @ -3 };
		positionBlock: #yourself;
		yourself.
	builder2 := RTVoronyjBuilder new
		objects: {  -10 @ 10 . 20 @ 30 . 50 @ -30 . 30 @ 20 };
		positionBlock: #yourself;
		yourself.
	builderCircle := RTVoronyjBuilder new
		objects: {  10 @ 40 . 40 @ 10 . 10 @ -20 . -20 @ 10 };
		positionBlock: #yourself;
		yourself.
	builder3 := RTVoronyjBuilder new
		objects: {  -10 @ 10 . 20 @ 30 . 50 @ -30 . -30 @ 40 };
		positionBlock: #yourself;
		yourself.! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 17:38'!
testCentersBySegment1
	self  
		assert: (builder centersBySegment 
			at: (GSegment with: -1 @ 1  with: 2 @ 3 )) first
		equals:  (9/4) @ (-5/8).  
	self  
		assert: (builder centersBySegment 
			at: (GSegment with: 2 @ 3  with: 5 @ -3 )) first
		equals:  (9/4) @ (-5/8).
	self  
		assert: (builder centersBySegment 
			at: (GSegment with: 5 @ -3  with: -1 @ 1 )) first
		equals:  (9/4) @ (-5/8).! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 19:45'!
testCloseShapeBetweenAndUsing

	self
		assert:
			(builderCircle
				closeShapeBetween: -32 @ 52
				and: 52 @ 52
				using: 10 @ 10)
		equals:
			{ GSegment with: -32 @ 52 with: 52 @ 52 } asOrderedCollection! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 16:35'!
testCloseShapeBetweenAndUsing1

	self
		assert:
			(builder2
				closeShapeBetween: (-9.666666666666666 @ 42.0)
				and: (-1.3333333333333333 @ -42.0) 
				using: -10 @ 10)
		equals:
			{ GSegment with: -9.666666666666666 @ 42 with: -22 @ 42 .
			 GSegment with: -22 @ 42  with: -22 @ -42  .
			GSegment with: -22 @ -42 with: (-1.3333333333333333 @ -42)
			} asOrderedCollection! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 16:36'!
testCloseShapeBetweenAndUsing2
	self
		assert:
			(builder2
				closeShapeBetween: (-22 @ 30)
				and: (-22 @ -10) 
				using: -10 @ 10)
		equals:
			{ GSegment with: -22 @ 30 with: -22 @ -10 } asOrderedCollection.
	self
		assert:
			(builder2
				closeShapeBetween: (-9 @ 42)
				and: (30 @ 42) 
				using: 20 @ 30)
		equals:
			{ GSegment with: -9 @ 42 with: 30 @ 42 } asOrderedCollection.
			! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 21:03'!
testCutvectors
	self  
		assert: ((builder3 cutVectors
			at:  -10 @ 10) asOrderedCollection at:1)
		equals:   (-5@35) .
	self  
		assert: ((builder3 cutVectors
			at:  -10 @ 10) asOrderedCollection at:2)
		equals:  (45/2)@ (-25/4) .
	
! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 13:39'!
testEdgesByVectors
	self  
		assert: (builder3 edgesByVectors
			at: (GSegment with: -10 @ 10 with: 20 @ 30 )) first origin
		equals:  -5 @ 35. 

	self  
		assert: (builder edgesByVectors
			at: (GSegment with: 2 @ 3 with: -1 @ 1 )) first origin
		equals:  (9/4) @ (-5/8)! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 14:06'!
testEdgesByVectors2
	self  
		assert: (builder edgesByVectors 
			at: (GSegment with: -1 @ 1  with: 2 @ 3 )) first origin
		equals:  (9/4) @ (-5/8).  
	self  
		assert: (builder edgesByVectors  
			at: (GSegment with: 2 @ 3  with: 5 @ -3 )) first direction
		equals:  ((13/4)@ (-1/8)).
! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 12:49'!
testPerpBisectorBySegment1
	self  
		assert: (builder  perpBisectorBySegment 
			at: (GSegment with: -1 @ 1 with: 2 @ 3 )) 
		equals:  (GSegment with: (9/4) @ (-5/8)  with: (-0.9666666666666668) @ 4.2) ! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/18/2014 17:51'!
testSegmentsByPoint
	self  
		assert: ((builder segmentsByPoint 
			at: (-1 @ 1) ) second v1)
		equals:  (9/4)@ (-5/8).  
	self  
		assert: ((builder segmentsByPoint 
			at: (-1 @ 1) ) second v2)
		equals:  (-0.13333333333333344@ -4.2).! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/18/2014 17:57'!
testSegmentsByPoint1
	self  
		assert: ((builder segmentsByPoint 
			at: (-1 @ 1) ) second v1)
		equals:  (9/4)@ (-5/8).  
	self  
		assert: ((builder segmentsByPoint 
			at: (-1 @ 1) ) second v2)
		equals:  (-0.13333333333333344@ -4.2).! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/19/2014 20:06'!
testSegmentsByPoint2
	self  
		assert: ((builder1 segmentsByPoint 
			at: (7 @ 4) ) second v1)
		equals:  (147 /34 )@ (149/34).  
	self  
		assert: ((builder1 segmentsByPoint 
			at: (7 @ 4) ) second v2)
		equals:  (8.6@7.233333333333333).! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 16:18'!
testShapesByPoint
	self  
		assert: ((builder2 shapesByPoint) 
			at: -10 @ 10)
		equals:   {(11 @ 11) . (-9.666666666666666 @ 42.0) . (-22.0 @ 42.0) . (-22.0 @ -42.0) . (-1.3333333333333333 @ -42.0) . (190/11) @ (-155/11)} asOrderedCollection .  
	self  
		assert: ((builder2 shapesByPoint) 
			at: 50 @ -30 )
		equals:   {(190/11) @ (-155/11) . (62.0 @ 3.8) . (62.0 @ -42.0) . (-1.3333333333333333 @ -42.0)} asOrderedCollection ! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/25/2014 17:22'!
testShapesByPoint1
	self  
	assert: (((RTVoronyjBuilder new objects: { -1 @ 1 . 2 @ 3 . 5 @ -3 };
		positionBlock: #yourself;yourself)shapesByPoint at: 2 @ 3) at:3)
		equals: (6.2 @ 4.2) . 
 
	! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/25/2014 17:22'!
testVoronyjBuilder
| v  o|

v := RTView new.
v @ RTZoomableView.
o:=RTVoronyjBuilder new .
o objects: { -10 @ 10 . 20 @ 30 . 50 @ -30 . -30 @ 40 }.
o positionBlock:#yourself.
	
o renderIn: v.

v 
	! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/1/2014 23:38'!
testVoronyjBuilder2
| v  o|

v := RTView new.
v @ RTZoomableView.
o:=RTVoronyjBuilder new .
o objects: { -10 @ 10 . 20 @ 30 . 50 @ -30 . -30 @ 40 }.
o positionBlock:#yourself.
	
o renderIn2: v.

v 
	! !

!GCircle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/5/2014 18:22'!
perpBisTo: segm using:boundaryPoints
	| vector |

	vector := GVector 
		origin: center  
		direction: segm midPoint.


	(segm locationOf:(boundaryPoints detect: [ :p | p ~= segm v1 and: [ p ~= segm v2 ]]))
	= 
	(segm locationOf: center )
		ifTrue: [ ^ vector ]
		ifFalse:[ ^ vector flipped ]! !

!GCircle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/5/2014 18:29'!
perpendicularBisectorsOn: boundaryPoints
	|polygonSegm firstP notUsedPoints currentP|
	currentP := boundaryPoints anyOne.
	firstP := currentP.
	notUsedPoints := boundaryPoints asOrderedCollection remove: currentP; yourself.
	polygonSegm := Dictionary new.
	
	[ notUsedPoints isNotEmpty ] whileTrue: [
		| nextP segm |
		nextP := notUsedPoints detectMin: [ :point | point dist: currentP ].
		segm := GSegment with: currentP with: nextP.
		polygonSegm
			at: segm
			put: (self  perpBisTo: segm using: boundaryPoints ).
		currentP := nextP.
		notUsedPoints remove: currentP
			].
			
		polygonSegm
			at: ( GSegment with: currentP with: firstP)
			put: ( self perpBisTo: ( GSegment with: currentP with: firstP) using: boundaryPoints).
	
	^ polygonSegm! !

!GTriangle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/5/2014 18:50'!
perpendicularBisectors
| center |
center := self circumscribedCircle center.
^ (self edgesByOpositeVertex associations collect:[ :assoc | |perp p1 p2|
	perp := assoc value perpendicularBisector.
	perp a = 0 
		ifFalse:[ p1 := (center x + 1) @ (perp yFor: center x + 1) .
					 p2 := (center x - 1) @ (perp yFor: center x - 1) ] 
		ifTrue:[ p1 := center + (1 @ 0).
				   p2 := center - (1 @ 0) ].
	
	assoc value ->
		(GVector
			origin: center
			direction: (
				(assoc key dist: p1) > (assoc key dist: p2)
					ifTrue: [ p1 ]
					ifFalse: [ p2 ])) ] ) asDictionary ! !

RTBuilder subclass: #RTAbstractVoronyjBuilder
	instanceVariableNames: 'objects dictPointsAndObject renderSites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:27'!
calculatePointsAndObject

	^ self subclassResponsibility ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/28/2014 16:33'!
centersBySegment
"first step: for every three point build triangle with circumscribed cirle. Take only that triangles that its circle doesn't have inside sites.
second step: return dictionary with the triangle side as key and the triangle circumscribed circle center as value"
	| dict points collOfPolygons|
	points := self points.
	collOfPolygons := OrderedCollection new.
	dict := Dictionary new.	
	points uniqueTriCombiDo: [ :fst :snd :trd |
		| triangle |
		triangle := GTriangle with: fst with: snd with: trd.
		(triangle
			isDegenerate not and: 
			[collOfPolygons
				noneSatisfy: [ :polygon | polygon includesAll: {fst . snd . trd} ] ]) ifTrue: [
				| circle |
				circle := triangle circumscribedCircle.
				((points copyWithoutAll: {fst . snd . trd})
					noneSatisfy: [ :point | circle contains: point ]) ifTrue: [ 
						(circle boundaryContainsThis: (points copyWithoutAll: {fst . snd . trd}) )
							ifFalse: [
								triangle edges do:[ :edge |
									(dict
										at: edge
										ifAbsentPut: [OrderedCollection  new ]) add: circle center ]]	
				  			ifTrue:[
								| pointsOnBoundary |
								pointsOnBoundary := circle boundaryContainsWhichOf: points.
								collOfPolygons add: pointsOnBoundary.
								(circle polygonOn: pointsOnBoundary) do: [ :edge |
									(dict
										at: edge
										ifAbsentPut: [ OrderedCollection  new ]) add: circle center ] ] ] ] ] .
		^ dict! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:28'!
clearCache

	dictPointsAndObject := nil! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 12:07'!
closeSegments: segments using: site
"for that shapes which are not closed build new segments on frame to close them."
	((segments flatCollect: #vertices)
		groupedBy: #yourself
		having: [ :each |
			each size = 1 ]) keys ifNotEmptyDo:[ :outliers |
				^ segments,
					(self closeShapeBetween: outliers first and: outliers last using: site) ].
	
	^ segments.! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 17:02'!
closeShapeBetween:point1 and: point2 using: site
| segm1 segm2 coll |
coll := OrderedCollection new.
(self frame hasOnOneSide: point1 and: point2)
		ifTrue:[coll add: (GSegment with: point1 with: point2)] 
		ifFalse:[ segm1 := self frame sideWhichHas: point1.
					 segm2 := self frame sideWhichHas: point2.
					((segm1 intersect: segm2) = nil) 
					    ifTrue:[|s1| s1:= self whichSideHas: site betweenItselfAnd: (GSegment with: point1 with: point2).
						(point1 dist: s1 v1) < (point1 dist: s1 v2) 
								ifTrue:[coll add: (GSegment with: point1  with: s1 v1);
							 				add: s1;
											add: (GSegment with: s1 v2  with: point2)] 
								ifFalse:[coll add: (GSegment with: point1  with: s1 v2);
											add: s1;
											add: (GSegment with: s1 v1  with: point2)]]				
						 ifFalse:[
							coll add: (GSegment with: (segm1 intersect:segm2) with:point1);
										add:(GSegment with: (segm1 intersect:segm2) with:point2 )]								
					].
				^coll ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 18:39'!
cutVectors
"2-nd step. (case with bag of points.) return dictionary with the triangle side as key and the perpendicular bisectors to it as value"
| dict  a b |
dict:= Dictionary new.
b:= self edgesByVectors.
(self edgesByVectors) keysAndValuesDo: [ :key :value| 
	""
	a:= value.
	"self halt".
	""
	((value size = 2 
		ifTrue:
			[ GSegment with: value first origin with: value last origin ]
		ifFalse:
			[ value first ]) cutWith: self frame) ifNotNilDo: [ :segment |
			{ key v1 . key v2 } do: [ :v | 
			(dict 
				at: v
				ifAbsentPut: [ Set new ]) add: segment v1; add: segment v2 ] ] ].
		
^ dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:27'!
dictPointsAndObject

	^ dictPointsAndObject ifNil: [ 
		dictPointsAndObject := self calculatePointsAndObject ]! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 19:25'!
doNotRenderSites

	self renderSites: false! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 13:37'!
edgesByVectors
"first step: for every three point build triangle with circumscribed cirle. Take only that triangles that its circle doesn't have inside sites.
second step: return dictionary with the triangle side as key and the ______ as value"
	| dict collOfPolygons|
	collOfPolygons := OrderedCollection new.
	dict := Dictionary new.	
	self points uniqueTriCombiDo: [ :fst :snd :trd |
		| triangle |
		triangle := GTriangle with: fst with: snd with: trd.
		(triangle
			isDegenerate not and: 
			[collOfPolygons
				noneSatisfy: [ :polygon | polygon includesAll: {fst . snd . trd} ] ]) ifTrue: [
				| circle |
				"self halt.	"
				circle := triangle circumscribedCircle.
				((self points copyWithoutAll: {fst . snd . trd})
					noneSatisfy: [ :point | circle contains: point ]) ifTrue: [ 
						(((self points copyWithoutAll: {fst . snd . trd}) select: [ :point | circle boundaryContains: point ])
							ifEmpty: [ triangle perpendicularBisectors ]	
				  			ifNotEmptyDo: [ :pointsOnBoundary |
								circle perpendicularBisectorsOn: (collOfPolygons add: pointsOnBoundary, {fst . snd . trd}) ])
									keysAndValuesDo: [ :edge :perpBis |
										(dict
											at: edge
											ifAbsentPut: [ OrderedCollection new: 2 ]) add: perpBis ] ] ] ].
		^ dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/18/2014 11:05'!
frame
| encompasingRectangle |

encompasingRectangle := self points min corner: self points max.

^encompasingRectangle expandBy: (encompasingRectangle extent * 0.2)! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 19:25'!
initialize
	super initialize.
	self renderSites: true! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/16/2014 16:54'!
objects
	^ objects! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:28'!
objects: anObject
	objects := anObject.
	self clearCache.! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 11:36'!
perpBisectorBySegment
"third step. return dictionary with the triangle side as key and the perpendicular bisectors to it as value"
| dict|
dict:= Dictionary new.
(self centersBySegment) keysAndValuesDo: [ :key :value| 
	value size = 2 
	ifTrue:
		[dict at: key put:( GSegment with:(value at:1) with:(value at:2) )]
	ifFalse:
		[dict at: key put:( GSegment with:(value at:1) with: (self pointForClosestToBorder: key) )] ].
^dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 12:04'!
perpBisectorBySegment1
"third step. return dictionary with the triangle side as key and the perpendicular bisectors to it as value"
| dict|
dict:= Dictionary new.
(self centersBySegment) keysAndValuesDo: [ :key :value| 
	value size = 2 
	ifTrue:
		[ ((self frame hasPoint: (value at:1)) and:[self frame hasPoint: (value at:2)])
		ifTrue:[
				dict at: key put:( GSegment with:(value at:1) with:(value at:2) )]
		ifFalse:[ (self frame hasPoint: (value at:1)) 
			ifTrue: 
					[dict at: key put:( GSegment 
					with:(value at:1) 
					with:(self frame intersectionPointsWithSegment: (GSegment with:(value at:1) with:(value at:2))))]
			ifFalse: 
					[(self frame hasPoint: (value at:2)) ifTrue:
						[dict at: key put:( GSegment 
						with:(value at:2) 
						with:(self frame intersectionPointsWithSegment: (GSegment with:(value at:1) with:(value at:2))))]]			
			]]
	ifFalse:
		[(self frame hasPoint: (value at:1)) ifTrue:[
				dict at: key put:( GSegment with:(value at:1) with: (self pointForClosestToBorder: key) )]] ].
^dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 13:19'!
perpBisectorBySegmentsOnLine
"third step for the case when all points lye on the line. 
return dictionary with the segment as key and the perpendicular bisectors to it as value"
| dict|
dict:= Dictionary new.
(self centersBySegment) keysAndValuesDo: [ :iKey :iValue| 
	iValue size = 2 
	ifTrue:
		[dict at: iKey put:( GSegment with:(iValue at:1) with:(iValue at:2) )]
	ifFalse:
		[dict at: iKey put:( GSegment with:(iValue at:1) with: (self pointForClosestToBorder: iKey) )] ].
^dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 6/28/2014 15:16'!
pointForClosestToBorder: segm
"return one of the intersection points with frame, which will be the second vertice of porpendicular bisector"
	| intPoints positionOfOther |
	intPoints := self frame intersectionPointsWithLine: (segm perpendicularBisector).
	positionOfOther := segm locationOf: (self points detect:[ :p |
		(segm locationOf: p) ~= 0 ]).
	^intPoints detect: [:point | 
			(segm locationOf: point) ~= positionOfOther ].
		
! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 21:26'!
points	
	^ self dictPointsAndObject keys! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 7/2/2014 11:03'!
pointsOnFrame
"3-rd step"
| pOnBoundary coll positionColl|
pOnBoundary := self points select: [ :point | self frame hasOnBoundary: point = true ].
coll := OrderedCollection new.
positionColl := Set new.
pOnBoundary allButLast withIndexDo: [ :fst :index1 |
		((self allButLast) allButFirst: index1)	withIndexDo: [ :snd :index2 | 	
				(self frame hasOnOneSide: fst and: snd) ifFalse:[coll add: (GSegment with: fst with: snd) ] 
		 ]].
coll do:[ :segm | 
		self points do:[:point |
			(segm locationOf: point) ifNotNil: [ (positionColl at: segm
										ifAbsentPut: [ Set  new ]) add: (segm locationOf: point)] ]].
positionColl select:[:values | values size = 1 ].
self edgesByVectors


! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/1/2014 23:42'!
renderIn2: aView
| segmentsByPoint |
segmentsByPoint := self shapesByPoint2.
self dictPointsAndObject keysAndValuesDo: [ :point :object | 
	aView add:
		(RTPolygon new
			vertices: ( segmentsByPoint at: point);
			color: Color transparent;
			elementOn: object).
	self renderSites ifTrue: [  
		aView add:
			((RTEllipse new
				size: self frame extent min * 0.03;
				color: Color black;
				elementOn: object)
					translateTo: point;
					yourself) ] ]! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 19:03'!
renderIn: aView
| shapesByPoint |
shapesByPoint := self shapesByPoint.
self dictPointsAndObject keysAndValuesDo: [ :point :object | 
	aView add:
		(RTPolygon new
			vertices: (shapesByPoint at: point);
			color: Color transparent;
			elementOn: object).
	self renderSites ifTrue: [  
		aView add:
			((RTEllipse new
				size: self frame extent min * 0.03;
				color: Color black;
				elementOn: object)
					translateTo: point;
					yourself) ] ]! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/23/2014 19:23'!
renderSites
	^ renderSites! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/23/2014 19:24'!
renderSites: aBoolean
	renderSites := aBoolean ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 12:49'!
segmentsByPoint
"fourth step. return dictionary with the site as key and the perpendicular bisectors (poligon segments) as value"
	| dict |
	dict := Dictionary new.
	self perpBisectorBySegment keysAndValuesDo:[:iKey :iValue|
		iKey vertices do:[:vert | 
			(dict at: vert ifAbsentPut: [OrderedCollection new]) add:iValue]  ].
	^ dict! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 13:18'!
segmentsByPointsOnLine
"fourth step for the case when all points lye on the line. 
return dictionary with the site as key and the perpendicular bisectors (poligon segments) as value"
	| dict |
	dict := Dictionary new.
	self perpBisectorBySegmentsOnLine keysAndValuesDo:[:iKey :iValue|
		iKey vertices do:[:vert | 
			(dict at: vert ifAbsentPut: [OrderedCollection new]) add:iValue]  ].
	^ dict! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/30/2014 22:37'!
shapesByPoint
"fifth step. return dictionary with the site as key and the poligon vertices as value."
	| shapesByPoint |
	shapesByPoint := Dictionary new.
	self segmentsByPoint keysAndValuesDo: [:point :segments | | coll clSegments |
		clSegments := self closeSegments: segments using: point.
		"shapesByPoint at: point put: (self closeSegments: segments using: point) ."
	"^ self segmentsByPoint associations collect: [ :assoc |
		| coll clSegments |
		clSegments := self closeSegments: assoc value using: assoc key."
		coll := OrderedCollection with: clSegments anyOne v1.

		[ clSegments isNotEmpty ] whileTrue: [ 
			| segment |
			clSegments remove:
			(segment := clSegments detect: [ :each |
				each boundBy: coll last]).
			coll add: (segment v1 = coll last
				ifFalse: [ segment v1 ]
				ifTrue:  [ segment v2 ]) ]. 
			shapesByPoint at: point put: coll allButLast].
	^ shapesByPoint! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:18'!
shapesByPoint2
"4-th step. return dictionary with the site as key and the poligon vertices as value."
"close shape"
	^self cutVectors collect: [ :vertices | GPolygon convexHullOn: vertices ].
! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/28/2014 15:20'!
whichSideHas: point betweenItselfAnd: segm
"return frame side which has between itself and segm the point, but not other points"
| position fram| 
	position := segm locationOf: ((self points copyWithout: point) detect:[ :p |
				(segm locationOf: p) ~= 0 ]).
			fram:= self frame.
	^(self frame edges) detect:[ :edge |
				(segm locationOf: edge v1)~= position  and:
				[(segm locationOf: edge v2)~= position]].! !

RTAbstractVoronyjBuilder subclass: #RTMDSVoronyjBuilder
	instanceVariableNames: 'relationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTMDSVoronyjBuilder class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:57'!
on: aCollection with: aBlock 
	^ self new on: aCollection with: aBlock! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 13:18'!
calculatePointsAndObject
	
	| objectArray aMatrix coordinates dict |
	objectArray := objects asArray.
	aMatrix := DhbMatrix new: objectArray size.
	objectArray 
		withIndexDo: [ :fst :index1 | 
			(objectArray allButFirst: index1 - 1)
				withIndexDo: [ :snd :index2 | |a| a:= relationBlock value: fst value: snd.
					aMatrix
						at: index1 at: index1 + index2 - 1 put: a;
						at: index1 + index2 - 1 at: index1 put: a ] ].
	self halt.
	coordinates := self сoordinates: (self matrixBInMDS: aMatrix).
	dict := Dictionary new.
	coordinates rows withIndexDo:[ :vect :index | 
		dict at: (vect first * 500 @ vect last * 500) put: (objectArray at: index)].
	^dict ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
jMatrixInMDS
	^ (DhbMatrix new: self numberOfItems with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: self numberOfItems with: [ :c :r | 1 / self numberOfItems ]) ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
jMatrixInMDSOf: size
	^ (DhbMatrix new: size with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: size with: [ :c :r | 1 / size ])! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
matrixBInMDS: aMatrix

	^((DhbMatrix new: aMatrix rows size with: [ :c :r | 
			c = r
				ifTrue: [ -1/2 ]
				ifFalse: [ 0 ] ]) * (self jMatrixInMDSOf: aMatrix rows size))* (aMatrix collect: #squared ) * (self jMatrixInMDSOf: aMatrix rows size)! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:56'!
on: aCollection with: aBlock 
	^ self
		relBlock: aBlock;
		on: aCollection! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/25/2014 17:22'!
relationBlock
	^ relationBlock ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:28'!
relationBlock: anObject
	relationBlock := anObject.
	self clearCache ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:56'!
сoordinates: matrBInMDS
	| j matrixOfTwoEigenvalues matrixOfTwoTranspEigenvectors |
	j := DhbJacobiTransformation matrix: matrBInMDS.
	matrixOfTwoEigenvalues := DhbMatrix diagonal: (j evaluate sort last: 2).
	matrixOfTwoTranspEigenvectors := (DhbMatrix rows: (j transform rows first: 2)) transpose.
	^ matrixOfTwoTranspEigenvectors * matrixOfTwoEigenvalues! !

RTAbstractVoronyjBuilder subclass: #RTVoronyjBuilder
	instanceVariableNames: 'positionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:45'!
calculatePointsAndObject
 |aDict|		
 aDict := Dictionary new.
 objects do: [ :object |
		 aDict at: (positionBlock value: object) put: object ].
 ^ aDict! !

!RTVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:30'!
dictPointsAndObject	

	^ (objects collect: [ :object |
		  (positionBlock value: object) ->object ]) asDictionary! !

!RTVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/25/2014 17:20'!
positionBlock
	^ positionBlock! !

!RTVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:29'!
positionBlock: anObject
	positionBlock := anObject.
	self clearCache ! !
